osgParticle::ParticleSystem Class Reference

`#include <ParticleSystem>`

Inheritance diagram for osgParticle::ParticleSystem:

## Classes

struct | ArrayData

## Public Types

enum | Alignment { BILLBOARD , FIXED }
enum | ParticleScaleReferenceFrame { LOCAL_COORDINATES , WORLD_COORDINATES }
enum | SortMode { NO_SORT , SORT_FRONT_TO_BACK , SORT_BACK_TO_FRONT }
typedef OpenThreads::Mutex | ReadWriterMutex
typedef OpenThreads::ScopedLock< OpenThreads::Mutex > | ScopedReadLock
typedef OpenThreads::ScopedLock< OpenThreads::Mutex > | ScopedWriteLock
Public Types inherited from osg::Drawable

enum

AttributeTypes {
VERTICES = 0 , WEIGHTS = 1 , NORMALS = 2 , COLORS = 3 ,
SECONDARY_COLORS = 4 , FOG_COORDS = 5 , ATTRIBUTE_6 = 6 , ATTRIBUTE_7 = 7 ,
TEXTURE_COORDS = 8 , TEXTURE_COORDS_0 = TEXTURE_COORDS , TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1 , TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2 ,
TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3 , TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4 , TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5 , TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6 ,
TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7
}

typedef DrawableUpdateCallback | UpdateCallback
typedef DrawableEventCallback | EventCallback
typedef DrawableCullCallback | CullCallback
typedef unsigned int | AttributeType
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ParticleSystem ()
| ParticleSystem (const ParticleSystem &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, ParticleSystem)
Alignment | getParticleAlignment () const
| Get the alignment type of particles.
void | setParticleAlignment (Alignment a)
| Set the alignment type of particles.
const osg::Vec3 & | getAlignVectorX () const
| Get the X-axis alignment vector.
void | setAlignVectorX (const osg::Vec3 &v)
| Set the X-axis alignment vector.
const osg::Vec3 & | getAlignVectorY () const
| Get the Y-axis alignment vector.
void | setAlignVectorY (const osg::Vec3 &v)
| Set the Y-axis alignment vector.
void | setAlignVectors (const osg::Vec3 &X, const osg::Vec3 &Y)
| Set the alignment vectors.
void | setParticleScaleReferenceFrame (ParticleScaleReferenceFrame rf)
ParticleScaleReferenceFrame | getParticleScaleReferenceFrame () const
const osg::BoundingBox & | getDefaultBoundingBox () const
| Get the default bounding box.
void | setDefaultBoundingBox (const osg::BoundingBox &bbox)
bool | getUseVertexArray () const
| Return true if we use vertex arrays for rendering particles.
void | setUseVertexArray (bool v)
bool | getUseShaders () const
| Return true if shaders are required.
void | setUseShaders (bool v)
bool | getDoublePassRendering () const
| Get the double pass rendering flag.
void | setDoublePassRendering (bool v)
bool | getFrozen () const
| Return true if the particle system is frozen.
bool | isFrozen () const
void | setFrozen (bool v)
int | numParticles () const
| Get the number of allocated particles (alive + dead).
int | numDeadParticles () const
| Get the number of dead particles.
bool | areAllParticlesDead () const
| Get whether all particles are dead.
Particle * | getParticle (int i)
| Get a pointer to the i-th particle.
const Particle * | getParticle (int i) const
| Get a const pointer to the i-th particle.
virtual Particle * | createParticle (const Particle *ptemplate)
| Create a new particle from the specified template (or the default one if `ptemplate` is null).
virtual void | destroyParticle (int i)
| Destroy the i-th particle.
virtual void | reuseParticle (int i)
| Reuse the i-th particle.
unsigned int | getLastFrameNumber () const
| Get the last frame number.
double & | getDeltaTime (double currentTime)
| Get the unique delta time for emitters and updaters to use.
Particle & | getDefaultParticleTemplate ()
| Get a reference to the default particle template.
const Particle & | getDefaultParticleTemplate () const
| Get a const reference to the default particle template.
void | setDefaultParticleTemplate (const Particle &p)
| Set the default particle template (particle is copied).
bool | getFreezeOnCull () const
| Get whether the particle system can freeze when culled.
void | setFreezeOnCull (bool v)
| Set whether the particle system can freeze when culled (default is true).
void | setDefaultAttributes (const std::string &texturefile="", bool emissive_particles=true, bool lighting=false, int texture_unit=0)
void | setDefaultAttributesUsingShaders (const std::string &texturefile="", bool emissive_particles=true, int texture_unit=0)
int | getLevelOfDetail () const
| (EXPERIMENTAL) Get the level of detail.
void | setLevelOfDetail (int v)
SortMode | getSortMode () const
| Get the sort mode.
void | setSortMode (SortMode mode)
double | getVisibilityDistance () const
| Get the visibility distance.
void | setVisibilityDistance (double distance)
virtual void | update (double dt, osg::NodeVisitor &nv)
| Update the particles. Don't call this directly, use a `ParticleSystemUpdater` instead.
virtual void | drawImplementation (osg::RenderInfo &renderInfo) const
virtual osg::BoundingBox | computeBoundingBox () const
ReadWriterMutex * | getReadWriteMutex () const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *state=0) const
virtual osg::VertexArrayState * | createVertexArrayStateImplementation (osg::RenderInfo &renderInfo) const
void | adjustEstimatedMaxNumOfParticles (int delta)
void | setEstimatedMaxNumOfParticles (int num)
int | getEstimatedMaxNumOfParticles () const
Public Member Functions inherited from osg::Drawable
| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Drawable)
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual void | computeDataVariance ()
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setInitialBound (const osg::BoundingBox &bbox)
const BoundingBox & | getInitialBound () const
const BoundingSphere & | getBound () const
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
virtual void | setShape (Shape *shape)
template<class T>
void | setShape (const ref_ptr< T > &shape)
Shape * | getShape ()
const Shape * | getShape () const
void | setSupportsDisplayList (bool flag)
bool | getSupportsDisplayList () const
void | setUseDisplayList (bool flag)
bool | getUseDisplayList () const
GLuint & | getDisplayList (unsigned int contextID) const
virtual void | setUseVertexBufferObjects (bool flag)
bool | getUseVertexBufferObjects () const
void | setUseVertexArrayObject (bool flag)
bool | getUseVertexArrayObject () const
virtual void | dirtyGLObjects ()
virtual unsigned int | getGLObjectSizeHint () const
void | draw (RenderInfo &renderInfo) const
void | drawInner (RenderInfo &renderInfo) const
virtual void | compileGLObjects (RenderInfo &renderInfo) const
void | setCreateVertexArrayStateCallback (CreateVertexArrayStateCallback *cb)
CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback ()
const CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback () const
VertexArrayState * | createVertexArrayState (RenderInfo &renderInfo) const
void | setVertexArrayStateList (VertexArrayStateList &vasl)
VertexArrayStateList & | getVertexArrayStateList ()
const VertexArrayStateList & | getVertexArrayStateList () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setDrawCallback (DrawCallback *dc)
DrawCallback * | getDrawCallback ()
const DrawCallback * | getDrawCallback () const
virtual bool | supports (const AttributeFunctor &) const
virtual void | accept (AttributeFunctor &)
virtual bool | supports (const ConstAttributeFunctor &) const
virtual void | accept (ConstAttributeFunctor &) const
virtual bool | supports (const PrimitiveFunctor &) const
virtual void | accept (PrimitiveFunctor &) const
virtual bool | supports (const PrimitiveIndexFunctor &) const
virtual void | accept (PrimitiveIndexFunctor &) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
virtual void | traverse (NodeVisitor &)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< Particle > | Particle_vector
typedef std::stack< Particle * > | Death_stack
typedef osg::buffered_object< ArrayData > | BufferedArrayData
Protected Types inherited from osg::Drawable
typedef osg::buffered_value< GLuint > | GLObjectList

## Protected Member Functions

virtual | ~ParticleSystem ()
ParticleSystem & | operator= (const ParticleSystem &)
void | update_bounds (const osg::Vec3 &p, float r)
Protected Member Functions inherited from osg::Drawable
Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Particle_vector | _particles
Death_stack | _deadparts
osg::BoundingBox | _def_bbox
Alignment | _alignment
osg::Vec3 | _align_X_axis
osg::Vec3 | _align_Y_axis
ParticleScaleReferenceFrame | _particleScaleReferenceFrame
bool | _useVertexArray
bool | _useShaders
bool | _dirty_uniforms
bool | _doublepass
bool | _frozen
osg::Vec3 | _bmin
osg::Vec3 | _bmax
bool | _reset_bounds_flag
bool | _bounds_computed
Particle | _def_ptemp
unsigned int | _last_frame
bool | _dirty_dt
bool | _freeze_on_cull
double | _t0
double | _dt
int | _detail
SortMode | _sortMode
double | _visibilityDistance
ReadWriterMutex | _readWriteMutex
int | _estimatedMaxNumOfParticles
BufferedArrayData | _bufferedArrayData
Protected Attributes inherited from osg::Drawable
BoundingBox | _initialBoundingBox
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundingBoxCallback
BoundingBox | _boundingBox
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
bool | _useVertexArrayObject
GLObjectList | _globjList
VertexArrayStateList | _vertexArrayStateList
ref_ptr< DrawCallback > | _drawCallback
ref_ptr< CreateVertexArrayStateCallback > | _createVertexArrayStateCallback
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Drawable
static GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
static void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
static void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
static unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

The heart of this class library; its purpose is to hold a set of particles and manage particle creation, update, rendering and destruction. You can add this drawable to any Geode as you usually do with other Drawable classes. Each instance of ParticleSystem is a separate set of particles; it provides the interface for creating particles and iterating through them (see the Emitter and Program classes).

## Member Typedef Documentation

## BufferedArrayData

typedef osg::buffered_object< ArrayData > osgParticle::ParticleSystem::BufferedArrayData

protected

## Death_stack

typedef std::stack<Particle*> osgParticle::ParticleSystem::Death_stack

protected

## Particle_vector

typedef std::vector<Particle> osgParticle::ParticleSystem::Particle_vector

protected

## ReadWriterMutex

typedef OpenThreads::Mutex osgParticle::ParticleSystem::ReadWriterMutex

## ScopedReadLock

typedef OpenThreads::ScopedLock<OpenThreads::Mutex> osgParticle::ParticleSystem::ScopedReadLock

## ScopedWriteLock

typedef OpenThreads::ScopedLock<OpenThreads::Mutex> osgParticle::ParticleSystem::ScopedWriteLock

## Member Enumeration Documentation

## Alignment

enum osgParticle::ParticleSystem::Alignment

Enumerator
BILLBOARD |
FIXED |

## ParticleScaleReferenceFrame

enum osgParticle::ParticleSystem::ParticleScaleReferenceFrame

Enumerator
LOCAL_COORDINATES |
WORLD_COORDINATES |

## SortMode

enum osgParticle::ParticleSystem::SortMode

Enumerator
NO_SORT |
SORT_FRONT_TO_BACK |
SORT_BACK_TO_FRONT |

## Constructor & Destructor Documentation

## ParticleSystem() [1/2]

osgParticle::ParticleSystem::ParticleSystem | ( |  | ) |

Referenced by META_Object(), operator=(), and ParticleSystem().

## ParticleSystem() [2/2]

osgParticle::ParticleSystem::ParticleSystem | ( | const ParticleSystem & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ParticleSystem(), and osg::CopyOp::SHALLOW_COPY.

## ~ParticleSystem()

virtual osgParticle::ParticleSystem::~ParticleSystem | ( |  | ) |

protected virtual

## Member Function Documentation

## adjustEstimatedMaxNumOfParticles()

void osgParticle::ParticleSystem::adjustEstimatedMaxNumOfParticles | ( | int | delta | ) |

inline

References _estimatedMaxNumOfParticles.

## areAllParticlesDead()

bool osgParticle::ParticleSystem::areAllParticlesDead | ( |  | ) | const

inline

Get whether all particles are dead.

References numDeadParticles(), and numParticles().

## computeBoundingBox()

virtual osg::BoundingBox osgParticle::ParticleSystem::computeBoundingBox | ( |  | ) | const

virtual

Compute the bounding box around Drawables's geometry.

Reimplemented from osg::Drawable.

## createParticle()

virtual Particle * osgParticle::ParticleSystem::createParticle | ( | const Particle * | ptemplate | ) |

virtual

Create a new particle from the specified template (or the default one if `ptemplate` is null).

Reimplemented in osgParticle::ConnectedParticleSystem.

References destroyParticle().

## createVertexArrayStateImplementation()

virtual osg::VertexArrayState * osgParticle::ParticleSystem::createVertexArrayStateImplementation | ( | osg::RenderInfo & | renderInfo | ) | const

virtual

Implementation of Create the VertexArrayState object.

Reimplemented from osg::Drawable.

## destroyParticle()

void osgParticle::ParticleSystem::destroyParticle | ( | int | i | ) |

inline virtual

Destroy the i-th particle.

References _particles.

Referenced by createParticle().

## drawImplementation()

virtual void osgParticle::ParticleSystem::drawImplementation | ( | osg::RenderInfo & |  | ) | const

virtual

drawImplementation(RenderInfo&) is a pure virtual method for the actual implementation of OpenGL drawing calls, such as vertex arrays and primitives, that must be implemented in concrete subclasses of the Drawable base class, examples include osg::Geometry and osg::ShapeDrawable. drawImplementation(RenderInfo&) is called from the draw(RenderInfo&) method, with the draw method handling management of OpenGL display lists, and drawImplementation(RenderInfo&) handling the actual drawing itself. renderInfo : The osg::RenderInfo object that encapsulates the current rendering information including the osg::State OpenGL state for the current graphics context.

Reimplemented from osg::Drawable.

Reimplemented in osgParticle::ConnectedParticleSystem.

## getAlignVectorX()

const osg::Vec3 & osgParticle::ParticleSystem::getAlignVectorX | ( |  | ) | const

inline

Get the X-axis alignment vector.

References _align_X_axis.

Referenced by META_Object().

## getAlignVectorY()

const osg::Vec3 & osgParticle::ParticleSystem::getAlignVectorY | ( |  | ) | const

inline

Get the Y-axis alignment vector.

References _align_Y_axis.

Referenced by META_Object().

## getDefaultBoundingBox()

const osg::BoundingBox & osgParticle::ParticleSystem::getDefaultBoundingBox | ( |  | ) | const

inline

Get the default bounding box.

References _def_bbox.

## getDefaultParticleTemplate() [1/2]

Particle & osgParticle::ParticleSystem::getDefaultParticleTemplate | ( |  | ) |

inline

Get a reference to the default particle template.

References _def_ptemp.

## getDefaultParticleTemplate() [2/2]

const Particle & osgParticle::ParticleSystem::getDefaultParticleTemplate | ( |  | ) | const

inline

Get a const reference to the default particle template.

References _def_ptemp.

## getDeltaTime()

double & osgParticle::ParticleSystem::getDeltaTime | ( | double | currentTime | ) |

inline

Get the unique delta time for emitters and updaters to use.

References _dirty_dt, _dt, and _t0.

## getDoublePassRendering()

bool osgParticle::ParticleSystem::getDoublePassRendering | ( |  | ) | const

inline

Get the double pass rendering flag.

References _doublepass.

## getEstimatedMaxNumOfParticles()

int osgParticle::ParticleSystem::getEstimatedMaxNumOfParticles | ( |  | ) | const

inline

References _estimatedMaxNumOfParticles.

## getFreezeOnCull()

bool osgParticle::ParticleSystem::getFreezeOnCull | ( |  | ) | const

inline

Get whether the particle system can freeze when culled.

References _freeze_on_cull.

## getFrozen()

bool osgParticle::ParticleSystem::getFrozen | ( |  | ) | const

inline

Return true if the particle system is frozen.

References _frozen.

## getLastFrameNumber()

unsigned int osgParticle::ParticleSystem::getLastFrameNumber | ( |  | ) | const

inline

Get the last frame number.

References _last_frame.

## getLevelOfDetail()

int osgParticle::ParticleSystem::getLevelOfDetail | ( |  | ) | const

inline

(EXPERIMENTAL) Get the level of detail.

References _detail.

Referenced by setDefaultAttributesUsingShaders().

## getParticle() [1/2]

Particle * osgParticle::ParticleSystem::getParticle | ( | int | i | ) |

inline

Get a pointer to the i-th particle.

References _particles.

Referenced by osgParticle::Operator::operateParticles().

## getParticle() [2/2]

const Particle * osgParticle::ParticleSystem::getParticle | ( | int | i | ) | const

inline

Get a const pointer to the i-th particle.

References _particles.

## getParticleAlignment()

ParticleSystem::Alignment osgParticle::ParticleSystem::getParticleAlignment | ( |  | ) | const

inline

Get the alignment type of particles.

References _alignment.

Referenced by META_Object().

## getParticleScaleReferenceFrame()

ParticleScaleReferenceFrame osgParticle::ParticleSystem::getParticleScaleReferenceFrame | ( |  | ) | const

inline

Get whether the particles should be scaled relative to world coordaintes or local coordinates.

References _particleScaleReferenceFrame.

## getReadWriteMutex()

ReadWriterMutex * osgParticle::ParticleSystem::getReadWriteMutex | ( |  | ) | const

inline

References _readWriteMutex.

## getSortMode()

ParticleSystem::SortMode osgParticle::ParticleSystem::getSortMode | ( |  | ) | const

inline

Get the sort mode.

References _sortMode.

## getUseShaders()

bool osgParticle::ParticleSystem::getUseShaders | ( |  | ) | const

inline

Return true if shaders are required.

References _useShaders.

## getUseVertexArray()

bool osgParticle::ParticleSystem::getUseVertexArray | ( |  | ) | const

inline

Return true if we use vertex arrays for rendering particles.

References _useVertexArray.

## getVisibilityDistance()

double osgParticle::ParticleSystem::getVisibilityDistance | ( |  | ) | const

inline

Get the visibility distance.

References _visibilityDistance.

## isFrozen()

bool osgParticle::ParticleSystem::isFrozen | ( |  | ) | const

inline

References _frozen.

## META_Object()

osgParticle::ParticleSystem::META_Object | ( | osgParticle | ,
|  | ParticleSystem | )

References getAlignVectorX(), getAlignVectorY(), getParticleAlignment(), ParticleSystem(), setAlignVectors(), setAlignVectorX(), setAlignVectorY(), and setParticleAlignment().

## numDeadParticles()

int osgParticle::ParticleSystem::numDeadParticles | ( |  | ) | const

inline

Get the number of dead particles.

References _deadparts.

Referenced by areAllParticlesDead().

## numParticles()

int osgParticle::ParticleSystem::numParticles | ( |  | ) | const

inline

Get the number of allocated particles (alive + dead).

References _particles.

Referenced by areAllParticlesDead(), and osgParticle::Operator::operateParticles().

## operator=()

ParticleSystem & osgParticle::ParticleSystem::operator= | ( | const ParticleSystem & |  | ) |

inline protected

References ParticleSystem().

## releaseGLObjects()

virtual void osgParticle::ParticleSystem::releaseGLObjects | ( | osg::State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Drawable.

## resizeGLObjectBuffers()

virtual void osgParticle::ParticleSystem::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Drawable.

## reuseParticle()

virtual void osgParticle::ParticleSystem::reuseParticle | ( | int | i | ) |

inline virtual

Reuse the i-th particle.

Reimplemented in osgParticle::ConnectedParticleSystem.

References _deadparts, and _particles.

## setAlignVectors()

void osgParticle::ParticleSystem::setAlignVectors | ( | const osg::Vec3 & | X,
|  | const osg::Vec3 & | Y )

inline

Set the alignment vectors.

References _align_X_axis, and _align_Y_axis.

Referenced by META_Object().

## setAlignVectorX()

void osgParticle::ParticleSystem::setAlignVectorX | ( | const osg::Vec3 & | v | ) |

inline

Set the X-axis alignment vector.

References _align_X_axis.

Referenced by META_Object().

## setAlignVectorY()

void osgParticle::ParticleSystem::setAlignVectorY | ( | const osg::Vec3 & | v | ) |

inline

Set the Y-axis alignment vector.

References _align_Y_axis.

Referenced by META_Object().

## setDefaultAttributes()

void osgParticle::ParticleSystem::setDefaultAttributes | ( | const std::string & | texturefile = "",
|  | bool | emissive_particles = true,
|  | bool | lighting = false,
|  | int | texture_unit = 0 )

A useful method to set the most common `StateAttribute`'s in one call. If `texturefile` is empty, then texturing is turned off.

## setDefaultAttributesUsingShaders()

void osgParticle::ParticleSystem::setDefaultAttributesUsingShaders | ( | const std::string & | texturefile = "",
|  | bool | emissive_particles = true,
|  | int | texture_unit = 0 )

A useful method to set the most common `StateAttribute` and use GLSL shaders to draw particles. At present, when enabling shaders in the particle system, user-defined shapes will not be usable. If `texturefile` is empty, then texturing is turned off.

References getLevelOfDetail(), and setLevelOfDetail().

## setDefaultBoundingBox()

void osgParticle::ParticleSystem::setDefaultBoundingBox | ( | const osg::BoundingBox & | bbox | ) |

inline

Set the default bounding box. The default bounding box is used when a real bounding box cannot be computed, for example because no particles has been updated yet.

References _def_bbox.

## setDefaultParticleTemplate()

void osgParticle::ParticleSystem::setDefaultParticleTemplate | ( | const Particle & | p | ) |

inline

Set the default particle template (particle is copied).

References _def_ptemp.

## setDoublePassRendering()

void osgParticle::ParticleSystem::setDoublePassRendering | ( | bool | v | ) |

inline

Set the double pass rendering flag. Double pass rendering avoids overdraw problems between particle systems and other opaque objects. If you can render all the particle systems after the opaque objects, then double pass is not necessary and can be turned off (best choice). If you set the default attributes with setDefaultAttributes, then the particle system will fall into a transparent bin.

References _doublepass.

## setEstimatedMaxNumOfParticles()

void osgParticle::ParticleSystem::setEstimatedMaxNumOfParticles | ( | int | num | ) |

inline

References _estimatedMaxNumOfParticles.

## setFreezeOnCull()

void osgParticle::ParticleSystem::setFreezeOnCull | ( | bool | v | ) |

inline

Set whether the particle system can freeze when culled (default is true).

References _freeze_on_cull.

## setFrozen()

void osgParticle::ParticleSystem::setFrozen | ( | bool | v | ) |

inline

Set or reset the frozen state. When the particle system is frozen, emitters and programs won't do anything on it.

References _frozen.

## setLevelOfDetail()

void osgParticle::ParticleSystem::setLevelOfDetail | ( | int | v | ) |

inline

(EXPERIMENTAL) Set the level of detail. The total number of particles is divided by the detail value to get the actual number of particles to be drawn. This value must be greater than zero.

References _detail.

Referenced by setDefaultAttributesUsingShaders().

## setParticleAlignment()

void osgParticle::ParticleSystem::setParticleAlignment | ( | Alignment | a | ) |

inline

Set the alignment type of particles.

References _alignment.

Referenced by META_Object().

## setParticleScaleReferenceFrame()

void osgParticle::ParticleSystem::setParticleScaleReferenceFrame | ( | ParticleScaleReferenceFrame | rf | ) |

inline

Set whether the particles should be scaled relative to world coordaintes or local coordinates.

References _particleScaleReferenceFrame.

## setSortMode()

void osgParticle::ParticleSystem::setSortMode | ( | SortMode | mode | ) |

inline

Set the sort mode. It will force resorting the particle list by the Z direction of the view coordinates. This can be used for the purpose of transparent rendering or `setVisibilityDistance()`.

References _sortMode.

## setUseShaders()

void osgParticle::ParticleSystem::setUseShaders | ( | bool | v | ) |

inline

Set to use GLSL shaders for rendering particles. Particles' parameters will be used as shader attribute arrays, and necessary variables, including the visibility distance, texture, etc, will be used and updated as uniforms.

References _dirty_uniforms, and _useShaders.

## setUseVertexArray()

void osgParticle::ParticleSystem::setUseVertexArray | ( | bool | v | ) |

inline

Set to use vertex arrays for rendering particles. Lots of variables will be omitted: particles' shape, alive or not, visibility distance, and so on, so the rendering result is not as good as we wish (although it's fast than using glBegin/glEnd). We had better use this for GLSL shaders, in which particle parameters will be kept as uniforms. This method is called automatically by `setDefaultAttributesUsingShaders()`.

References _useVertexArray.

## setVisibilityDistance()

void osgParticle::ParticleSystem::setVisibilityDistance | ( | double | distance | ) |

inline

Set the visibility distance which allows the particles to be rendered only when depth is inside the distance. When using shaders, it can work well directly; otherwise the sort mode should also be set to pre-compute depth.

References _dirty_uniforms, _useShaders, and _visibilityDistance.

## update()

virtual void osgParticle::ParticleSystem::update | ( | double | dt,
|  | osg::NodeVisitor & | nv )

virtual

Update the particles. Don't call this directly, use a `ParticleSystemUpdater` instead.

## update_bounds()

void osgParticle::ParticleSystem::update_bounds | ( | const osg::Vec3 & | p,
|  | float | r )

inline protected

References _bmax, _bmin, _bounds_computed, _reset_bounds_flag, osg::Vec3f::x(), osg::Vec3f::y(), and osg::Vec3f::z().

## Member Data Documentation

## _align_X_axis

osg::Vec3 osgParticle::ParticleSystem::_align_X_axis

protected

Referenced by getAlignVectorX(), setAlignVectors(), and setAlignVectorX().

## _align_Y_axis

osg::Vec3 osgParticle::ParticleSystem::_align_Y_axis

protected

Referenced by getAlignVectorY(), setAlignVectors(), and setAlignVectorY().

## _alignment

Alignment osgParticle::ParticleSystem::_alignment

protected

Referenced by getParticleAlignment(), and setParticleAlignment().

## _bmax

osg::Vec3 osgParticle::ParticleSystem::_bmax

protected

Referenced by update_bounds().

## _bmin

osg::Vec3 osgParticle::ParticleSystem::_bmin

protected

Referenced by update_bounds().

## _bounds_computed

bool osgParticle::ParticleSystem::_bounds_computed

protected

Referenced by update_bounds().

## _bufferedArrayData

BufferedArrayData osgParticle::ParticleSystem::_bufferedArrayData

mutable protected

## _deadparts

Death_stack osgParticle::ParticleSystem::_deadparts

protected

Referenced by numDeadParticles(), and reuseParticle().

## _def_bbox

osg::BoundingBox osgParticle::ParticleSystem::_def_bbox

protected

Referenced by getDefaultBoundingBox(), and setDefaultBoundingBox().

## _def_ptemp

Particle osgParticle::ParticleSystem::_def_ptemp

protected

Referenced by getDefaultParticleTemplate(), getDefaultParticleTemplate(), and setDefaultParticleTemplate().

## _detail

int osgParticle::ParticleSystem::_detail

protected

Referenced by getLevelOfDetail(), and setLevelOfDetail().

## _dirty_dt

bool osgParticle::ParticleSystem::_dirty_dt

mutable protected

Referenced by getDeltaTime().

## _dirty_uniforms

bool osgParticle::ParticleSystem::_dirty_uniforms

protected

Referenced by setUseShaders(), and setVisibilityDistance().

## _doublepass

bool osgParticle::ParticleSystem::_doublepass

protected

Referenced by getDoublePassRendering(), and setDoublePassRendering().

## _dt

double osgParticle::ParticleSystem::_dt

protected

Referenced by getDeltaTime().

## _estimatedMaxNumOfParticles

int osgParticle::ParticleSystem::_estimatedMaxNumOfParticles

protected

Referenced by adjustEstimatedMaxNumOfParticles(), getEstimatedMaxNumOfParticles(), and setEstimatedMaxNumOfParticles().

## _freeze_on_cull

bool osgParticle::ParticleSystem::_freeze_on_cull

protected

Referenced by getFreezeOnCull(), and setFreezeOnCull().

## _frozen

bool osgParticle::ParticleSystem::_frozen

protected

Referenced by getFrozen(), isFrozen(), and setFrozen().

## _last_frame

unsigned int osgParticle::ParticleSystem::_last_frame

mutable protected

Referenced by getLastFrameNumber().

## _particles

Particle_vector osgParticle::ParticleSystem::_particles

protected

Referenced by destroyParticle(), getParticle(), getParticle(), osgParticle::ConnectedParticleSystem::getStartParticle(), osgParticle::ConnectedParticleSystem::getStartParticle(), numParticles(), and reuseParticle().

## _particleScaleReferenceFrame

ParticleScaleReferenceFrame osgParticle::ParticleSystem::_particleScaleReferenceFrame

protected

Referenced by getParticleScaleReferenceFrame(), and setParticleScaleReferenceFrame().

## _readWriteMutex

ReadWriterMutex osgParticle::ParticleSystem::_readWriteMutex

mutable protected

Referenced by getReadWriteMutex().

## _reset_bounds_flag

bool osgParticle::ParticleSystem::_reset_bounds_flag

protected

Referenced by update_bounds().

## _sortMode

SortMode osgParticle::ParticleSystem::_sortMode

protected

Referenced by getSortMode(), and setSortMode().

## _t0

double osgParticle::ParticleSystem::_t0

protected

Referenced by getDeltaTime().

## _useShaders

bool osgParticle::ParticleSystem::_useShaders

protected

Referenced by getUseShaders(), setUseShaders(), and setVisibilityDistance().

## _useVertexArray

bool osgParticle::ParticleSystem::_useVertexArray

protected

Referenced by getUseVertexArray(), and setUseVertexArray().

## _visibilityDistance

double osgParticle::ParticleSystem::_visibilityDistance

protected

Referenced by getVisibilityDistance(), and setVisibilityDistance().

The documentation for this class was generated from the following file:

- ParticleSystem